# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ChannelContainerFormat',
    'ChannelLatencyMode',
    'ChannelMultitrackInputConfigurationMaximumResolution',
    'ChannelMultitrackInputConfigurationPolicy',
    'ChannelPreset',
    'ChannelType',
    'IngestConfigurationIngestProtocol',
    'IngestConfigurationState',
    'RecordingConfigurationRenditionConfigurationRenditionSelection',
    'RecordingConfigurationRenditionConfigurationRenditionsItem',
    'RecordingConfigurationState',
    'RecordingConfigurationThumbnailConfigurationRecordingMode',
    'RecordingConfigurationThumbnailConfigurationResolution',
    'RecordingConfigurationThumbnailConfigurationStorageItem',
    'StageAutoParticipantRecordingConfigurationMediaTypesItem',
]


class ChannelContainerFormat(str, Enum):
    """
    Indicates which content-packaging format is used (MPEG-TS or fMP4). If multitrackInputConfiguration is specified and enabled is true, then containerFormat is required and must be set to FRAGMENTED_MP4. Otherwise, containerFormat may be set to TS or FRAGMENTED_MP4. Default: TS.
    """
    TS = "TS"
    FRAGMENTED_MP4 = "FRAGMENTED_MP4"


class ChannelLatencyMode(str, Enum):
    """
    Channel latency mode.
    """
    NORMAL = "NORMAL"
    LOW = "LOW"


class ChannelMultitrackInputConfigurationMaximumResolution(str, Enum):
    """
    Maximum resolution for multitrack input. Required if enabled is true.
    """
    SD = "SD"
    HD = "HD"
    FULL_HD = "FULL_HD"


class ChannelMultitrackInputConfigurationPolicy(str, Enum):
    """
    Indicates whether multitrack input is allowed or required. Required if enabled is true.
    """
    ALLOW = "ALLOW"
    REQUIRE = "REQUIRE"


class ChannelPreset(str, Enum):
    """
    Optional transcode preset for the channel. This is selectable only for ADVANCED_HD and ADVANCED_SD channel types. For those channel types, the default preset is HIGHER_BANDWIDTH_DELIVERY. For other channel types (BASIC and STANDARD), preset is the empty string ("").
    """
    EMPTY = ""
    HIGHER_BANDWIDTH_DELIVERY = "HIGHER_BANDWIDTH_DELIVERY"
    CONSTRAINED_BANDWIDTH_DELIVERY = "CONSTRAINED_BANDWIDTH_DELIVERY"


class ChannelType(str, Enum):
    """
    Channel type, which determines the allowable resolution and bitrate. If you exceed the allowable resolution or bitrate, the stream probably will disconnect immediately.
    """
    STANDARD = "STANDARD"
    BASIC = "BASIC"
    ADVANCED_SD = "ADVANCED_SD"
    ADVANCED_HD = "ADVANCED_HD"


class IngestConfigurationIngestProtocol(str, Enum):
    """
    Ingest Protocol.
    """
    RTMP = "RTMP"
    RTMPS = "RTMPS"


class IngestConfigurationState(str, Enum):
    """
    State of IngestConfiguration which determines whether IngestConfiguration is in use or not.
    """
    ACTIVE = "ACTIVE"
    INACTIVE = "INACTIVE"


class RecordingConfigurationRenditionConfigurationRenditionSelection(str, Enum):
    """
    Resolution Selection indicates which set of renditions are recorded for a stream.
    """
    ALL = "ALL"
    NONE = "NONE"
    CUSTOM = "CUSTOM"


class RecordingConfigurationRenditionConfigurationRenditionsItem(str, Enum):
    FULL_HD = "FULL_HD"
    HD = "HD"
    SD = "SD"
    LOWEST_RESOLUTION = "LOWEST_RESOLUTION"


class RecordingConfigurationState(str, Enum):
    """
    Recording Configuration State.
    """
    CREATING = "CREATING"
    CREATE_FAILED = "CREATE_FAILED"
    ACTIVE = "ACTIVE"


class RecordingConfigurationThumbnailConfigurationRecordingMode(str, Enum):
    """
    Thumbnail Recording Mode, which determines whether thumbnails are recorded at an interval or are disabled.
    """
    INTERVAL = "INTERVAL"
    DISABLED = "DISABLED"


class RecordingConfigurationThumbnailConfigurationResolution(str, Enum):
    """
    Resolution indicates the desired resolution of recorded thumbnails.
    """
    FULL_HD = "FULL_HD"
    HD = "HD"
    SD = "SD"
    LOWEST_RESOLUTION = "LOWEST_RESOLUTION"


class RecordingConfigurationThumbnailConfigurationStorageItem(str, Enum):
    SEQUENTIAL = "SEQUENTIAL"
    LATEST = "LATEST"


class StageAutoParticipantRecordingConfigurationMediaTypesItem(str, Enum):
    AUDIO_VIDEO = "AUDIO_VIDEO"
    AUDIO_ONLY = "AUDIO_ONLY"
